'use strict';

const express = require('express');
const SerialPort = require("serialport");

const PORT = 8080;
const HOST = '127.0.0.1';

const app = express();

app.use(express.static(__dirname + "/public"));

const Readline = require('@serialport/parser-readline');
const port = new SerialPort('COM3', { baudRate: 9600 });
const parser = port.pipe(new Readline({ delimiter: '\n' }));// Read the port data

port.on("open", () => {
    console.log('serial port open');
});

const server = require('http').Server(app)
const io = require('socket.io')(server);

io.on('connection', (socket) => {
    socket.on('go', (val) => {
        port.write("g");
    });

    socket.on('reset', (val) => {
        port.write("r");
    });

    parser.on('data', (data) => {
        console.log(data.toString());
        socket.emit('data', data.toString());
    });
});

server.listen(PORT, HOST, () => {
    console.log(`Server is running on http://${HOST}:${PORT}`);
});

